use crate::system::internal::EventHandlerHandle;

use super::Event;

pub struct EventResolver {
    handlers: Vec<EventHandlerHandle>,
}

impl EventResolver {
    pub fn new() -> Self {
        Self {
            handlers: Vec::new(),
        }
    }

    pub fn register_handler(&mut self, handler: EventHandlerHandle) {
        self.handlers.push(handler);
    }

    pub fn dispatch_event(&self, event: Event) {
        for handler in &self.handlers {
            let event_any = event.value.as_ref();
            handler.handler.handle(&handler.system, event_any);
        }
    }
}
