use std::any::{Any, TypeId};

pub(crate) mod internal;

#[derive(Debug)]
pub struct Event {
    pub id: TypeId,
    pub value: Box<dyn Any + Send + Sync>,
}

impl Event {
    pub fn new<S: 'static + Send + Sync>(value: S) -> Self {
        Self {
            id: TypeId::of::<S>(),
            value: Box::new(value),
        }
    }
}
